diff -Nru ircd.old/include/channel_mode.h ircd-hybrid-7.0-rus1.1/include/channel_mode.h
--- ircd.old/include/channel_mode.h	2003-06-17 12:38:47.000000000 +0400
+++ ircd-hybrid-7.0-rus1.1/include/channel_mode.h	2003-10-04 11:44:56.203125000 +0400
@@ -68,6 +68,7 @@
 #define CAN_SEND_NO	0
 #define CAN_SEND_NONOP  1
 #define CAN_SEND_OPV	2
+#define CANNOT_SEND_NOCOLOR 3
 
 
 /* Channel related flags */
@@ -96,6 +97,7 @@
 #define MODE_TOPICLIMIT 0x0040
 #define MODE_INVITEONLY 0x0080
 #define MODE_NOPRIVMSGS 0x0100
+#define MODE_NOCOLOR    0x0200
 #define MODE_BAN        0x0400
 #define MODE_EXCEPTION  0x0800
 #define MODE_INVEX	0x2000
diff -Nru ircd.old/modules/core/m_message.c ircd-hybrid-7.0-rus1.1/modules/core/m_message.c
--- ircd.old/modules/core/m_message.c	2003-06-17 12:38:47.000000000 +0400
+++ ircd-hybrid-7.0-rus1.1/modules/core/m_message.c	2003-10-04 02:38:02.828125000 +0400
@@ -476,6 +476,15 @@
       source_p->user->last = CurrentTime;
   }
 
+  /* lets deny colors in channel */
+  if (chptr->mode.mode & MODE_NOCOLOR)
+    if (strchr((char *)text, 3) || strchr((char *)text, 27))
+    {
+      sendto_one(source_p, form_str(ERR_CANNOTSENDTOCHAN),
+                 me.name, source_p->name, chname);
+      return;
+    }
+
   /* chanops and voiced can flood their own channel with impunity */
   if ((result = can_send(vchan, source_p)))
   {
diff -Nru ircd.old/modules/core/m_sjoin.c ircd-hybrid-7.0-rus1.1/modules/core/m_sjoin.c
--- ircd.old/modules/core/m_sjoin.c	2003-06-17 12:38:47.000000000 +0400
+++ ircd-hybrid-7.0-rus1.1/modules/core/m_sjoin.c	2003-10-04 11:33:26.031250000 +0400
@@ -179,6 +179,8 @@
       case 't':
         mode.mode |= MODE_TOPICLIMIT;
         break;
+      case 'c':
+        mode.mode |= MODE_NOCOLOR;
 #ifdef ANONOPS
       case 'a':
 	if(ConfigChannel.use_anonops)
@@ -740,6 +742,7 @@
   { MODE_MODERATED,  'm' },
   { MODE_INVITEONLY, 'i' },
   { MODE_PRIVATE,    'p' },
+  { MODE_NOCOLOR,    'c' },
 #ifdef ANONOPS
   { MODE_HIDEOPS,    'a' },
 #endif
diff -Nru ircd.old/src/channel_mode.c ircd-hybrid-7.0-rus1.1/src/channel_mode.c
--- ircd.old/src/channel_mode.c	2003-06-17 12:38:47.000000000 +0400
+++ ircd-hybrid-7.0-rus1.1/src/channel_mode.c	2003-10-04 12:28:33.437500000 +0400
@@ -495,6 +495,8 @@
     *mbuf++ = 'i';
   if (chptr->mode.mode & MODE_NOPRIVMSGS)
     *mbuf++ = 'n';
+  if (chptr->mode.mode & MODE_NOCOLOR)
+    *mbuf++ = 'c';
 #ifdef ANONOPS
   if (chptr->mode.mode & MODE_HIDEOPS)
     *mbuf++ = 'a';
@@ -1874,7 +1876,7 @@
   {chm_nosuch, NULL},				  /* a */
 #endif
   {chm_ban, NULL},                                /* b */
-  {chm_nosuch, NULL},                             /* c */
+  {chm_simple, (void *) MODE_NOCOLOR},            /* c */
   {chm_nosuch, NULL},                             /* d */
   {chm_except, NULL},                             /* e */
   {chm_nosuch, NULL},                             /* f */
